<!--suppress CheckEmptyScriptTag -->
<template>
  <metrocheck-map
    @feature-enter="handleFeatureEnterPositions"
    @feature-leave="handleFeatureLeavePosition"
  >
    <metrocheck-layer-lines-simple :displayed-lines="$props.displayedLines" />
    <metrocheck-layer-positions-symbol :displayed-lines="$props.displayedLines" />
  </metrocheck-map>
</template>

<script>
  import MetrocheckMap from './Map/Map'
  import MetrocheckLayerLinesSimple from './Map/LayerLinesSimple'
  import MetrocheckLayerPositionsSymbol from './Map/LayerPositionsSymbol'

  export default {
    name: 'MetrocheckMainMap',

    components: {
      MetrocheckLayerPositionsSymbol,
      MetrocheckLayerLinesSimple,
      MetrocheckMap,
    },

    props: {
      displayedLines: { type: Array, required: true },
      featureHovered: { type: Object },
    },

    methods: {
      handleFeatureLeavePosition: function () {
        this.$emit('update:featureHovered', null)
      },
      handleFeatureEnterPositions: function (event) {
        this.$emit('update:featureHovered', Object.assign(event.features[0].properties, { type: event.features[0].layer.id }))
      },
    },
  }
</script>
